/*  Copyright (C) 2012-2020 by László Nagy
    This file is part of Bear.

    Bear is a tool to generate compilation database for clang tooling.

    Bear is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bear is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

// specific platform indicator, should not using like this. ()needs to be deprecated)
#define SUPPORT_PRELOAD

// header checks
#define HAVE_SPAWN_H
#define HAVE_UNISTD_H
#define HAVE_SPAWN_H
#define HAVE_DLFCN_H
#define HAVE_ERRNO_H
#define HAVE_UNISTD_H
#define HAVE_SYS_UTSNAME_H
#define HAVE_SYS_WAIT_H
#define HAVE_GNU_LIB_NAMES_H

// OSX specific (needs to be deprecated)
/* #undef HAVE_NSGETENVIRON */

// dynamic linker
#define HAVE_DLOPEN
#define HAVE_DLSYM
#define HAVE_DLERROR
#define HAVE_DLCLOSE
#define HAVE_RTLD_NEXT

// errno values
#define HAVE_EACCES
#define HAVE_ENOENT
#define HAVE_UNAME

// string.h function
#define HAVE_STRERROR_R

// unistd.h might declare the environ symbol
#define HAVE_ENVIRON

// confstr and macros
#define HAVE_CONFSTR
#define HAVE_CS_PATH
#define HAVE_CS_GNU_LIBC_VERSION
#define HAVE_CS_GNU_LIBPTHREAD_VERSION

// const expression about this project
constexpr char VERSION[] = "3.0.7";

constexpr char CITNAMES_DEFAULT_PATH[] = "/usr/bin/citnames";
constexpr char INTERCEPT_DEFAULT_PATH[] = "/usr/bin/intercept";
constexpr char LIBRARY_DEFAULT_PATH[] = "/usr/libexec/bear/libexec.so";
constexpr char EXECUTOR_DEFAULT_PATH[] = "/usr/libexec/bear/er";
constexpr char WRAPPER_DEFAULT_PATH[] = "/usr/libexec/bear/wrapper.d";
