// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: supervise.proto
// Original file comments:
//  Copyright (C) 2012-2020 by László Nagy
// This file is part of Bear.
//
// Bear is a tool to generate compilation database for clang tooling.
//
// Bear is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Bear is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef GRPC_supervise_2eproto__INCLUDED
#define GRPC_supervise_2eproto__INCLUDED

#include "supervise.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc_impl {
class CompletionQueue;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc_impl

namespace grpc {
namespace experimental {
template <typename RequestT, typename ResponseT>
class MessageAllocator;
}  // namespace experimental
}  // namespace grpc

namespace rpc {

// This represents a (remote) supervisor process to set up program execution.
//
// A supervisor process executes a single program in the hope that it can
// get information about the state of the child process. But to decide what
// is the right strategy to intercept the relevant events from the child
// process can be done upfront.
//
// This interface describes a remote service which can be queried for how to
// execute the child program. Can resolve the executable name (in case of
// wrapper session) or update the environment variables (for both kind of
// sessions).
class Supervisor final {
 public:
  static constexpr char const* service_full_name() {
    return "rpc.Supervisor";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Resolve the executable name for the child process.
    //
    // Used in a wrapper session, when the build systems executes our wrapper
    // instead of the real command. Then the wrapper calls the supervisor to
    // find out which program is the real one to execute.
    virtual ::grpc::Status ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::rpc::ResolveResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>> AsyncResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>>(AsyncResolveProgramRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>> PrepareAsyncResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>>(PrepareAsyncResolveProgramRaw(context, request, cq));
    }
    // Update the environments for the child process.
    //
    // This is used for both wrapper and library sessions. The environment
    // variables are influencing how the processes behaves and which ones
    // are executed. It also specify the event sink (the interceptor) location.
    virtual ::grpc::Status Update(::grpc::ClientContext* context, const ::rpc::Environment& request, ::rpc::Environment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>> AsyncUpdate(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>>(AsyncUpdateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>> PrepareAsyncUpdate(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>>(PrepareAsyncUpdateRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      // Resolve the executable name for the child process.
      //
      // Used in a wrapper session, when the build systems executes our wrapper
      // instead of the real command. Then the wrapper calls the supervisor to
      // find out which program is the real one to execute.
      virtual void ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResolveProgram(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void ResolveProgram(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::ResolveResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Update the environments for the child process.
      //
      // This is used for both wrapper and library sessions. The environment
      // variables are influencing how the processes behaves and which ones
      // are executed. It also specify the event sink (the interceptor) location.
      virtual void Update(::grpc::ClientContext* context, const ::rpc::Environment* request, ::rpc::Environment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Update(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::Environment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Update(::grpc::ClientContext* context, const ::rpc::Environment* request, ::rpc::Environment* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void Update(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::Environment* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
    };
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>* AsyncResolveProgramRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::ResolveResponse>* PrepareAsyncResolveProgramRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>* AsyncUpdateRaw(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::rpc::Environment>* PrepareAsyncUpdateRaw(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::rpc::ResolveResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>> AsyncResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>>(AsyncResolveProgramRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>> PrepareAsyncResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>>(PrepareAsyncResolveProgramRaw(context, request, cq));
    }
    ::grpc::Status Update(::grpc::ClientContext* context, const ::rpc::Environment& request, ::rpc::Environment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::Environment>> AsyncUpdate(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::Environment>>(AsyncUpdateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::Environment>> PrepareAsyncUpdate(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::rpc::Environment>>(PrepareAsyncUpdateRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) override;
      void ResolveProgram(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::ResolveResponse* response, std::function<void(::grpc::Status)>) override;
      void ResolveProgram(::grpc::ClientContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ResolveProgram(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::ResolveResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void Update(::grpc::ClientContext* context, const ::rpc::Environment* request, ::rpc::Environment* response, std::function<void(::grpc::Status)>) override;
      void Update(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::Environment* response, std::function<void(::grpc::Status)>) override;
      void Update(::grpc::ClientContext* context, const ::rpc::Environment* request, ::rpc::Environment* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void Update(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::rpc::Environment* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>* AsyncResolveProgramRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::rpc::ResolveResponse>* PrepareAsyncResolveProgramRaw(::grpc::ClientContext* context, const ::rpc::ResolveRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::rpc::Environment>* AsyncUpdateRaw(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::rpc::Environment>* PrepareAsyncUpdateRaw(::grpc::ClientContext* context, const ::rpc::Environment& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ResolveProgram_;
    const ::grpc::internal::RpcMethod rpcmethod_Update_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Resolve the executable name for the child process.
    //
    // Used in a wrapper session, when the build systems executes our wrapper
    // instead of the real command. Then the wrapper calls the supervisor to
    // find out which program is the real one to execute.
    virtual ::grpc::Status ResolveProgram(::grpc::ServerContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response);
    // Update the environments for the child process.
    //
    // This is used for both wrapper and library sessions. The environment
    // variables are influencing how the processes behaves and which ones
    // are executed. It also specify the event sink (the interceptor) location.
    virtual ::grpc::Status Update(::grpc::ServerContext* context, const ::rpc::Environment* request, ::rpc::Environment* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResolveProgram() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolveProgram(::grpc::ServerContext* context, ::rpc::ResolveRequest* request, ::grpc::ServerAsyncResponseWriter< ::rpc::ResolveResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Update() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdate(::grpc::ServerContext* context, ::rpc::Environment* request, ::grpc::ServerAsyncResponseWriter< ::rpc::Environment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ResolveProgram<WithAsyncMethod_Update<Service > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ResolveProgram() {
      ::grpc::Service::experimental().MarkMethodCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::rpc::ResolveRequest, ::rpc::ResolveResponse>(
          [this](::grpc::experimental::CallbackServerContext* context, const ::rpc::ResolveRequest* request, ::rpc::ResolveResponse* response) { return this->ResolveProgram(context, request, response); }));}
    void SetMessageAllocatorFor_ResolveProgram(
        ::grpc::experimental::MessageAllocator< ::rpc::ResolveRequest, ::rpc::ResolveResponse>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::rpc::ResolveRequest, ::rpc::ResolveResponse>*>(
          ::grpc::Service::experimental().GetHandler(0))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::experimental::ServerUnaryReactor* ResolveProgram(::grpc::experimental::CallbackServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_Update() {
      ::grpc::Service::experimental().MarkMethodCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::rpc::Environment, ::rpc::Environment>(
          [this](::grpc::experimental::CallbackServerContext* context, const ::rpc::Environment* request, ::rpc::Environment* response) { return this->Update(context, request, response); }));}
    void SetMessageAllocatorFor_Update(
        ::grpc::experimental::MessageAllocator< ::rpc::Environment, ::rpc::Environment>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::rpc::Environment, ::rpc::Environment>*>(
          ::grpc::Service::experimental().GetHandler(1))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::experimental::ServerUnaryReactor* Update(::grpc::experimental::CallbackServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) { return nullptr; }
  };
  typedef ExperimentalWithCallbackMethod_ResolveProgram<ExperimentalWithCallbackMethod_Update<Service > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResolveProgram() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Update() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResolveProgram() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolveProgram(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Update() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ResolveProgram() {
      ::grpc::Service::experimental().MarkMethodRawCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::experimental::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResolveProgram(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::experimental::ServerUnaryReactor* ResolveProgram(::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/) { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_Update() {
      ::grpc::Service::experimental().MarkMethodRawCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::experimental::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Update(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::experimental::ServerUnaryReactor* Update(::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/) { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResolveProgram : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResolveProgram() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::rpc::ResolveRequest, ::rpc::ResolveResponse>(std::bind(&WithStreamedUnaryMethod_ResolveProgram<BaseClass>::StreamedResolveProgram, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ResolveProgram() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResolveProgram(::grpc::ServerContext* /*context*/, const ::rpc::ResolveRequest* /*request*/, ::rpc::ResolveResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResolveProgram(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::rpc::ResolveRequest,::rpc::ResolveResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Update : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Update() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::rpc::Environment, ::rpc::Environment>(std::bind(&WithStreamedUnaryMethod_Update<BaseClass>::StreamedUpdate, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_Update() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Update(::grpc::ServerContext* /*context*/, const ::rpc::Environment* /*request*/, ::rpc::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::rpc::Environment,::rpc::Environment>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ResolveProgram<WithStreamedUnaryMethod_Update<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ResolveProgram<WithStreamedUnaryMethod_Update<Service > > StreamedService;
};

}  // namespace rpc


#endif  // GRPC_supervise_2eproto__INCLUDED
